rts: Rip out support for STM invariants
ClosedPublic

Authored by bgamari on May 31 2018, 10:29 AM.

Details

Summary

This feature has some very serious correctness issues (Trac #14310), introduces a
great deal of complexity, and hasn't seen wide usage. Consequently we are
removing it, as proposed in Proposal Trac #77 [1]. This is heavily based on a patch
from fryguybob.

[1] https://github.com/ghc-proposals/ghc-proposals/pull/77

Test Plan

Validate

Diff Detail

Repository
rGHC Glasgow Haskell Compiler
Lint
Automatic diff as part of commit; lint not applicable.
Unit
Automatic diff as part of commit; unit tests not applicable.
bgamari created this revision.May 31 2018, 10:29 AM
bgamari updated this revision to Diff 16618.May 31 2018, 10:51 AM

Add changelog

simonmar accepted this revision.Jun 1 2018, 5:03 AM

Nice!

rts/PrimOps.cmm
1327–1328

What's the reason we're leaving this in place as a no-op?

This revision is now accepted and ready to land.Jun 1 2018, 5:03 AM
bgamari planned changes to this revision.Jun 2 2018, 9:56 AM
bgamari added inline comments.
rts/PrimOps.cmm
1327–1328

Whoops, yes, it should be dropped.

bgamari marked 2 inline comments as done.Jun 2 2018, 10:52 AM
This revision was not accepted when it landed; it landed in state Changes Planned.Jun 2 2018, 6:46 PM
This revision was automatically updated to reflect the committed changes.